<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/forms/pickerresults.lib.js">
//@overridden /alfresco/templates/webscripts/org/alfresco/repository/forms/pickerchildren.get.js

function main()
{
   var argsFilterType = args['filterType'],
      argsSelectableType = args['selectableType'],
      argsSearchTerm = args['searchTerm'],
      argsMaxResults = args['size'],
      argsXPath = args['xpath'],
      argsRootNode = args['rootNode'],
      argsRequiredRole = args['requiredRole'],
      pathElements = url.service.split("/"),
      parent = null,
      rootNode = companyhome,
      results = [],
      categoryResults = null,
      resultObj = null,
      lastPathElement = null;
   
   if (logger.isLoggingEnabled())
   {
      logger.log("children type = " + url.templateArgs.type);
      logger.log("argsSelectableType = " + argsSelectableType);
      logger.log("argsFilterType = " + argsFilterType);
      logger.log("argsSearchTerm = " + argsSearchTerm);
      logger.log("argsMaxResults = " + argsMaxResults);
      logger.log("argsXPath = " + argsXPath);
      logger.log("argsRequiredRole = " + argsRequiredRole);
      logger.log("argsRootNode = " + argsRootNode);
   }
         
   try
   {
      // construct the NodeRef from the URL
      var nodeRef = url.templateArgs.store_type + "://" + url.templateArgs.store_id + "/" + url.templateArgs.id;
      
      // determine if we need to resolve the parent NodeRef
      
      if (argsXPath != null)
      {
         // resolve the provided XPath to a NodeRef
         var nodes = search.xpathSearch(argsXPath);
         if (nodes.length > 0)
         {
            nodeRef = String(nodes[0].nodeRef);
         }
      }

      // default to max of 100 results
      var maxResults = 100;
      if (argsMaxResults != null)
      {
         // force the argsMaxResults var to be treated as a number
         maxResults = parseInt(argsMaxResults, 10) || maxResults;
      }

      if (url.templateArgs.type == "authority")
      {
    	 if (argsSelectableType == "cm:person" && nodeRef!==undefined && nodeRef!==null)
         {
            findSiteUsers(argsSearchTerm, maxResults, results, nodeRef, argsRequiredRole);
         } 
    	 else if (argsSelectableType == "cm:person")
         {
            findUsers(argsSearchTerm, maxResults, results);
         }
         else if (argsSelectableType == "cm:authorityContainer")
         {
            findGroups(argsSearchTerm, maxResults, results);
         }
         else
         {
            // combine groups and users
            findGroups(argsSearchTerm, maxResults, results);
            findUsers(argsSearchTerm, maxResults, results);
         }
      }
      
      if (logger.isLoggingEnabled())
         logger.log("Found " + results.length + " results");
   }
   catch (e)
   {
      var msg = e.message;
      
      if (logger.isLoggingEnabled())
         logger.log(msg);
      
      status.setCode(500, msg);
      
      return;
   }

   model.parent = parent;
   model.rootNode = rootNode;
   model.results = results;
}

function isItemSelectable(node, selectableType)
{
   var selectable = true;
   
   if (selectableType !== null && selectableType !== "")
   {
      selectable = node.isSubType(selectableType);
      
      if (!selectable)
      {
         // the selectableType could also be an aspect,
         // if the node has that aspect it is selectable
         selectable = node.hasAspect(selectableType);
      }
   }
   
   return selectable;
}

/* Sort the results by case-insensitive name */
function sortByName(a, b)
{
   return (b.properties.name.toLowerCase() > a.properties.name.toLowerCase() ? -1 : 1);
}

function findUsers(filterTerm, maxResults, results)
{
   var paging = utils.createPaging(maxResults, -1);
   
   var personRefs = people.getPeoplePaging(filterTerm, paging, "lastName", true);
   
   // create person object for each result
   for each(var personRef in personRefs)
   {
      // add to results
      results.push(
      {
         item: createPersonResult(search.findNode(personRef)),
         selectable: true
      });
   }
}

function findGroups(searchTerm, maxResults, results)
{
   if (logger.isLoggingEnabled())
      logger.log("Finding groups matching pattern: " + searchTerm);
   
   var paging = utils.createPaging(maxResults, 0);
   var searchResults = groups.getGroupsInZone(searchTerm, "APP.DEFAULT", paging, "displayName");
   for each(var group in searchResults)
   {
      if (logger.isLoggingEnabled())
         logger.log("found group = " + group.fullName);
         
      // add to results
      results.push(
      {
         item: createGroupResult(group.groupNode),
         selectable: true 
      });
   }
   
   // sort the groups by name alphabetically
   if (results.length > 0)
   {
      results.sort(function(a, b)
      {
         return (a.item.properties.name < b.item.properties.name) ? -1 : (a.item.properties.name > b.item.properties.name) ? 1 : 0;
      });
   }
}

function findSiteUsers(filterTerm, maxResults, results, nodeRef, requiredRole)
{
   var paging = utils.createPaging(maxResults, -1);
   var node = search.findNode(nodeRef);
   
   if(node == null) {
	   throw new Exception("Could not find nodeRef for " + nodeRef);
   }
      
   //Get the site where the start location node belongs
   var siteShortName = node.siteShortName;

   var ctx = Packages.org.springframework. web.context.ContextLoader.getCurrentWebApplicationContext();

   var realSiteService = ctx.getBean("SiteService");
   
   //Use site service instead since we are only interested in finding site limited users here
   filterTerm = filterTerm + "*";
   var personObjs = realSiteService.listMembersInfo(siteShortName, filterTerm, requiredRole, maxResults, true);


   logger.log("Found " + personObjs.size() + " site users applying filter " + filterTerm);

   // create person object for each result
   for (var i=0;i<personObjs.size();i++) {
      var personObj = personObjs.get(i);
      var person = people.getPerson(personObj.memberName);
      results.push(
      {
         item: createPersonResult(person),
         selectable: true
      });
   }
   
   logger.log("FindSiteUsers done");
}

main();