<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/site/site.put.json.js">
<import resource="classpath:/alfresco/extension/templates/webscripts/no/lyse/alfresco/repo/project/project.lib.js">

function addProjectMetadata() 
{
  var nodeRef = model.site.node.nodeRef;
  var site = model.site;
  var siteNode = site.node;

  logger.log("Editing project metadata for site " + site.shortName + " (" + nodeRef + ")");
  var projectNumber = getJsonValueOrNull(siteNode, json, "projectNumber", true);
  var projectStatus = getJsonValueOrNull(siteNode, json, "projectStatus", true);
  var projectStartDate = getJsonValueOrNull(siteNode, json, "projectStartDate", true);
  var projectEndDate = getJsonValueOrNull(siteNode, json, "projectEndDate", true);
  var projectCaseNumber = getJsonValueOrNull(siteNode, json, "projectCaseNumber", true);
  var projectType = getJsonValueOrNull(siteNode, json, "projectType", true);
  var projectLevel = getJsonValueOrNull(siteNode, json, "projectLevel", true);

  //The following two properties are copied from the default form fields
  var projectName = getJsonValueOrNull(siteNode, json, "title", false);
  var projectDescription = getJsonValueOrNull(siteNode, json, "description", false);
  siteNode.properties["lysep:projectName"] = projectName;
  siteNode.properties["lysep:projectDescription"] = projectDescription;
  siteNode.save();

  //Lookup of project manager
  var projectManagerNodeRef = getJsonValueOrNull(siteNode, json, "projectManager", false);  
  logger.log("projectManagerNodeRef = " + projectManagerNodeRef);
  if(projectManagerNodeRef != null)
  {
    var projectManagerNew = search.findNode(projectManagerNodeRef);
    var projectManagerNewUsername = projectManagerNew.properties["cm:userName"];
    if(siteNode.properties["lysep:projectManagerUsername"] != projectManagerNewUsername)
    {
      //Change project manager
      logger.log("Changing assoc Project->Project Manager: " + json.get("shortName") + "->" + projectManagerNewUsername);
      var projectManagerBefore = people.getPerson(siteNode.properties["lysep:projectManagerUsername"]);
      siteNode.removeAssociation(projectManagerBefore, "lysep:projectManager");
      siteNode.createAssociation(projectManagerNew, "lysep:projectManager");

      var projectManagerNewFullName = projectManagerNew.properties["cm:firstName"] + " " + projectManagerNew.properties["cm:lastName"];
      logger.log("projectManagerUsername=" + projectManagerNewUsername);
      logger.log("projectManagerFullName=" + projectManagerNewFullName);
      siteNode.properties["lysep:projectManagerUsername"] = projectManagerNewUsername;
      siteNode.properties["lysep:projectManagerFullName"] = projectManagerNewFullName;
      siteNode.save();
    }
  }
  //Save both site and site node
  siteNode.save();
  site.save();
}

function checkForDuplicateName() 
{
  var query = "TYPE:\"lysep:project\" AND @cm\\:title:\"" + json.get("title") + "\"";
  logger.log("Query for finding dupliate site names: " + query);
  var nodes = search.luceneSearch(query);
  if (nodes.length > 1) 
  { // We expect one site to exist (this one)
    site = model.site;
    logger.log("Detected duplicate site title. Resetting to old name for site " + site.shortName);
    site.title = site.node.properties["lysep:projectName"];
    // Save the site
    site.save();
    
    // Return 500
    status.setCode(500, "A project named " + site.title + " already exists");
    return true;
  }
  else
  {
    return false;
  }
}

if (model.site != undefined && model.site != null) 
{
  if (checkForDuplicateName()) 
  {
    status.setCode(status.STATUS_BAD_REQUEST, "error.duplicateName");
  } 
  else 
  {
    addProjectMetadata();
  }
}



