<import resource="classpath:/alfresco/templates/webscripts/org/alfresco/repository/site/sites.post.json.js">
<import resource="classpath:/alfresco/extension/templates/webscripts/no/lyse/alfresco/repo/project/project.lib.js">

function DuplicateNameException(message) {
   this.message = message;
   this.code = status.STATUS_BAD_REQUEST
   this.name = "DuplicateNameException";
}

function addProjectMetadata() {
  var nodeRef = model.site.node.nodeRef;
  var site = search.findNode(nodeRef);

  logger.log("Adding project metadata to site "+json.get("shortName")+" ("+nodeRef+")");
  var projectNumber = getJsonValueOrNull(site, json, "projectNumber", true);
  var projectStatus = getJsonValueOrNull(site, json, "projectStatus", true);
  var projectStartDate = getJsonValueOrNull(site, json, "projectStartDate", true);
  var projectEndDate = getJsonValueOrNull(site, json, "projectEndDate", true);
  var projectCaseNumber = getJsonValueOrNull(site, json, "projectCaseNumber", true);
  var projectType = getJsonValueOrNull(site, json, "projectType", true);
  //var projectId = getJsonValueOrNull(site, json, "projectId", true); System managed
  var projectLevel = getJsonValueOrNull(site, json, "projectLevel", true);

  //The following two properties are copied from the default form fields
  var projectName = getJsonValueOrNull(site, json, "title", false);
  var projectDescription = getJsonValueOrNull(site, json, "description", false);
  site.properties["lysep:projectName"] = projectName;
  site.properties["lysep:projectDescription"] = projectDescription;
  site.save();
  
  //Lookup of project manager
  var projectManagerNodeRef = getJsonValueOrNull(site, json, "projectManager", false);  
  logger.log("projectManagerNodeRef=" + projectManagerNodeRef);
  if (projectManagerNodeRef) {
	  var projectManager = search.findNode(projectManagerNodeRef);
	  var projectManagerUsername = projectManager.properties["cm:userName"];
	  var projectManagerFullName = projectManager.properties["cm:firstName"]+" "+projectManager.properties["cm:lastName"];
	  logger.log("projectManagerUsername=" + projectManagerUsername);
	  logger.log("projectManagerFullName=" + projectManagerFullName);
	  site.properties["lysep:projectManagerUsername"] = projectManagerUsername;
	  site.properties["lysep:projectManagerFullName"] = projectManagerFullName;
	  site.save();
	  logger.log("Adding assoc Project->Project Manager: " + json.get("shortName") + "->"+ projectManagerUsername);
	  site.createAssociation(projectManager, "lysep:projectManager");
	  site.save();
	  //Add project manager as member to the project
	  var role = "SiteManager"; // "SiteManager", "SiteCollaborator", "SiteContributor", "SiteConsumer"
	  var theSite = siteService.getSite(json.get("shortName"));
	  theSite.setMembership(projectManagerUsername, role);
	  logger.log("Adding "+projectManagerUsername + " as site manager for project site "+json.get("shortName"));
  }

  //Lookup parent project
  var parentSiteName = getJsonValueOrNull(site, json, "subProject", false); 
  logger.log("parentSiteName=" + parentSiteName);
  if (parentSiteName!=null) {
    //var parentProject = search.findNode(parentProjectNodeRef);
	var parentSite = siteService.getSite(parentSiteName);
	var parentProject = parentSite.node;
	var parentProjectNodeRef = parentProject.nodeRef;
	
    logger.log("Adding assoc Parent project -> project: " + parentProject.properties["st:shortName"] + " ("+parentProjectNodeRef+") ->"+ json.get("shortName")+" ("+ nodeRef +")");
    parentProject.createAssociation(site, "lysep:subProject");
    site.save();
    //Find parent program
    if (parentProject.properties["lysep:projectLevel"] == "program") {    
      site.properties["lysep:projectProgram"] = parentProject.properties["lysep:projectName"];
    } else {
      site.properties["lysep:projectProgram"] = parentProject.properties["lysep:projectProgram"];
    }
    logger.log("lysep:projectProgram=" + site.properties["lysep:projectProgram"]);
    site.save();
  }  

  
  //throw new DuplicateNameException("error.duplicateName");
}

//If duplicate site name is found rollback creation of site
function checkForDuplicateName() {
  var query = "TYPE:\"lysep:project\" AND @cm\\:title:\""+ json.get("title") +"\"";
  logger.log("Query for finding dupliate site names: "+query)
  var nodes = search.luceneSearch(query);
  if (nodes.length>1) { //We expect one site to exist (this one)
    logger.log("Detected duplicate site title. Rolling back creation of site "+json.get("shortName"));
    var site = siteService.getSite(json.get("shortName"));
    if (site == null)
    {
      // Return 404
      status.setCode(404, "Created project site " + shortName + " does not exist");
      return;
    }

    // Delete the site
    site.deleteSite();
    return true;
  }
  return false;
}

if (model.site!=undefined && model.site!=null) {
  if (checkForDuplicateName()) {
    status.setCode(status.STATUS_BAD_REQUEST, "error.duplicateName");
  } else {
   addProjectMetadata();
  }
}